# assuming a fresh shell for each component to be built, this holds
# handy stuff used by all (well, most)

# first few vars not meant for export
##BUILDROOT=/pb3/bld/kde343/build
##RTROOT=/opt/kde343
##TARS_DIR=/pb3/bld/kde343/tars
##PATCHES_DIR=/pb3/bld/kde343/patches
TOP=/v/src/kde
VER=3.5.9
BUILDROOT=$TOP/$VER
RTROOT=/opt/kde359
TARS_DIR=$TOP/$VER/src
PATCHES_DIR=$TOP/$VER/patches
DEBUG_BLD=no

QT_PATCHES_DIR=$TOP/$VER/qt-patches
CC="cc -Kpthread"
CXX="CC -Kpthread"
NM="/usr/ccs/bin/nm -p"
XMKMF="/usr/local/bin/xmkmf"
LIBART_CONFIG=/bin/false
LOGDIR=$BUILDROOT/logs
export CC CXX NM LIBART_CONFIG LOGDIR XMKMF

if [ $DEBUG_BLD = "yes" ] ; then
  GLOBALCFLAGS="-g -D_EFTSAFE"
else
  GLOBALCFLAGS="-O2 -D_EFTSAFE -DNDEBUG -DNO_DEBUG"
fi


QTDIR=/usr/lib/qt3
KDEDIR=$RTROOT
KDEHOME=$HOME/dot-kde
PATH=$BUILDROOT/xenv/bin:/usr/bin:/usr/ccs/bin:/usr/sbin:/usr/java/bin:/usr/X11R6/bin:/usr/gnu/bin:$KDEDIR/bin
if [ "$LD_LIBRARY_PATH" ]
then
    # check to see if we already have a ";"
    echo $LD_LIBRARY_PATH | grep ";" > /dev/null 2>&1
    if [ $? -eq 0 ]
    then
      LD_LIBRARY_PATH="$LD_LIBRARY_PATH:/usr/X11R6/lib:$QTDIR/lib:$KDEDIR/lib"
    else
      LD_LIBRARY_PATH="$LD_LIBRARY_PATH;/usr/X11R6/lib:$QTDIR/lib:$KDEDIR/lib"
    fi
else
    LD_LIBRARY_PATH=";/usr/X11R6/lib:$QTDIR/lib:$KDEDIR/lib"
fi
export QTDIR KDEDIR PATH KDEHOME LD_LIBRARY_PATH

# set the RPATH the xenv programs enforce
BUILD_RPATH=$KDEDIR/lib
export BUILD_RPATH

# an environment var to keep the xenv programs from getting loopy
XENVLEVEL=0
export XENVLEVEL

# coax udk behaviour from configure scripts
CFGHINT="--build i686-unknown-sysv5UnixWare7.1.4 --host i686-unknown-sysv5UnixWare7.1.4"

GLOBALCFLAGS="$GLOBALCFLAGS -DSVR4 -DHAVE_PROTOTYPES \
              -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64"
  
