/* for kde fix "open" so it doesn't interfere with C++ member functions of same name */
#ifndef _EFTSAFE
#error _EFTSAFE must be defined for this process to work
#endif
/* look for string "kde" below to identify changes */

/* 
 *  
 * 	Copyright (c) 2003-2004 The SCO Group, Inc. All Rights Reserved. 
 *  
 * 		THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF 
 * 				The SCO Group, Inc. 
 *  
 * 	The copyright notice above does not evidence any actual or intended 
 * 	publication of such source code. 
 *  
*/ 

#ifndef _FCNTL_H
#define _FCNTL_H
#ident	"@(#)unixsrc:usr/src/common/head/fcntl.h /main/1"

#include <sys/types.h>
#include <sys/fcntl.h>

#ifndef S_IRWXU
#   define S_IRWXU	00700	/* read, write, execute: owner */
#   define S_IRUSR	00400	/* read permission: owner */
#   define S_IWUSR	00200	/* write permission: owner */
#   define S_IXUSR	00100	/* execute permission: owner */
#   define S_IRWXG	00070	/* read, write, execute: group */
#   define S_IRGRP	00040	/* read permission: group */
#   define S_IWGRP	00020	/* write permission: group */
#   define S_IXGRP	00010	/* execute permission: group */
#   define S_IRWXO	00007	/* read, write, execute: other */
#   define S_IROTH	00004	/* read permission: other */
#   define S_IWOTH	00002	/* write permission: other */
#   define S_IXOTH	00001	/* execute permission: other */
#   define S_ISUID	0x800	/* set user id on execution */
#   define S_ISGID	0x400	/* set group id on execution */
#endif

#ifndef SEEK_SET
#   define SEEK_SET	0	/* Set file pointer to "offset" */
#   define SEEK_CUR	1	/* Set file pointer to current plus "offset" */
#   define SEEK_END	2	/* Set file pointer to EOF plus "offset" */
#endif

#ifdef __cplusplus
extern "C" {
#endif

extern int	fcntl(int, int, ...);

#ifndef __cplusplus /* kde */
extern int	open(const char *, int, ...);
#endif /* kde */

extern int	creat(const char *, mode_t);
#if defined(_LARGEFILE64_SOURCE) || defined(_FILE_OFFSET_BITS) \
	|| !defined(_XOPEN_SOURCE) && !defined(_POSIX_SOURCE) \
		&& !defined(_POSIX_C_SOURCE)
extern int	open32(const char *, int, ...);
extern int	creat32(const char *, mode_t);
extern int	open64(const char *, int, ...);
extern int	creat64(const char *, mode_t);
#endif /*defined(_LARGEFILE64_SOURCE) || ...*/

#ifdef __cplusplus
}
#endif

#if _FILE_OFFSET_BITS - 0 == 32
#undef open
#define open	open32
#undef creat
#define creat	creat32
#elif _FILE_OFFSET_BITS - 0 == 64
#undef open
#define open	open64
#undef creat
#define creat	creat64
#elif defined(_FILE_OFFSET_BITS)
#error "_FILE_OFFSET_BITS, if defined, must be 32 or 64"
#endif /*_FILE_OFFSET_BITS*/

/* kde fixup */
#ifndef __cplusplus
/* no intervention required */
#else

/* replace defines with more friendly inline functions */

#undef open

#if _FILE_OFFSET_BITS - 0 == 32

inline int
open(const char * __x1, int __x2, mode_t __x3 = 0)
{
  return open32(__x1, __x2, __x3);
}

#else

inline int
open(const char * __x1, int __x2, mode_t __x3 = 0)
{
  return open64(__x1, __x2, __x3);
}

#endif /*_FILE_OFFSET_BITS */
#endif      /* ifndef __cplusplus : kde */

#endif /*_FCNTL_H*/
