#ifndef KDE_XENV_SOCKET_H
#define KDE_XENV_SOCKET_H


/* 
 * replace some #defines that foul up KDE C++ usage.
 */


#ifndef _EFTSAFE
#error _EFTSAFE must be defined for this process to work
#endif

#ifndef __cplusplus

/* no intervention required */
#include </usr/include/sys/socket.h>

#else

#include </usr/include/sys/socket.h>

/* now replace delected defines with inline functions */

#undef connect
#undef accept
#undef bind
#undef getpeername
#undef getsockname
#undef recvfrom
#undef recvmsg
#undef sendto
#undef sendmsg

#undef getsockopt
#undef listen
#undef recv
#undef send
#undef setsockopt
#undef shutdown
#undef socket
#undef socketpair

#undef bindresvport
#undef setsockname
#undef setpeername

inline int connect(int __a1, const struct sockaddr *__a2, socklen_t __a3)
{
      return _xconnect(__NETLIB_VERSION__, __a1, __a2, __a3);
}

inline int accept(int __a1, struct sockaddr *__a2, socklen_t *__a3)
{
      return _xaccept(__NETLIB_VERSION__, __a1, __a2, __a3);
}

inline int bind(int __a1, const struct sockaddr *__a2, socklen_t __a3)
{
      return _xbind(__NETLIB_VERSION__, __a1, __a2, __a3);
}

inline int getpeername(int __a1, struct sockaddr *__a2, socklen_t *__a3)
{
      return _xgetpeername(__NETLIB_VERSION__, __a1, __a2, __a3);
}

inline int getsockname(int __a1, struct sockaddr *__a2, socklen_t *__a3)
{
      return _xgetsockname(__NETLIB_VERSION__, __a1, __a2, __a3);
}

inline ssize_t recvfrom(int __a1, void *__a2, size_t __a3, int __a4, struct sockaddr *__a5, socklen_t *__a6)
{
      return _xrecvfrom(__NETLIB_VERSION__, __a1, __a2, __a3, __a4, __a5, __a6);
}

inline ssize_t recvmsg(int __a1, struct msghdr *__a2, int __a3)
{
      return _xrecvmsg(__NETLIB_VERSION__, __a1, __a2, __a3);
}

inline ssize_t sendto(int __a1, const void *__a2, socklen_t __a3, int __a4, const struct sockaddr *__a5, socklen_t __a6)
{
      return _xsendto(__NETLIB_VERSION__, __a1, __a2, __a3, __a4, __a5, __a6);
}

inline ssize_t sendmsg(int __a1, const struct msghdr *__a2, int __a3)
{
      return _xsendmsg(__NETLIB_VERSION__, __a1, __a2, __a3);
}

inline int getsockopt(int __a1, int __a2, int __a3, void *__a4, socklen_t *__a5)
{
  return ( _xgetsockopt(__NETLIB_VERSION__, __a1, __a2, __a3, __a4, __a5) );
}

inline int listen(int __a1, int __a2)
{
  return ( _xlisten(__NETLIB_VERSION__, __a1, __a2) );
}

inline ssize_t recv(int __a1, void *__a2, size_t __a3, int __a4)
{
  return ( _xrecv(__NETLIB_VERSION__, __a1, __a2, __a3, __a4) );
}

inline ssize_t send(int __a1, const void *__a2, size_t __a3, int __a4)
{
  return ( _xsend(__NETLIB_VERSION__, __a1, __a2, __a3, __a4) );
}

inline int setsockopt(int __a1, int __a2, int __a3, const void *__a4, socklen_t __a5)
{
  return ( _xsetsockopt(__NETLIB_VERSION__, __a1, __a2, __a3, __a4, __a5) );
}

inline int shutdown(int __a1, int __a2)
{
  return ( _xshutdown(__NETLIB_VERSION__, __a1, __a2) );
}

inline int socket(int __a1, int __a2, int __a3)
{
  return ( _xsocket(__NETLIB_VERSION__, __a1, __a2, __a3) );
}

/* more and more open source expects 0 and -1 as the only return values
   for socketpair.  Map UW return values to match that. */
inline int socketpair(int __a1, int __a2, int __a3, int __a4[2])
{
  return ( (_xsocketpair(__NETLIB_VERSION__, __a1, __a2, __a3, __a4) == -1) ? -1 : 0 );
}

inline int bindresvport(int __a1, struct sockaddr *__a2)
{
      return _xbindresvport(__NETLIB_VERSION__, __a1, __a2);
}

inline int setsockname(int __a1, struct sockaddr *__a2, socklen_t __a3)
{
      return _xsetsockname(__NETLIB_VERSION__, __a1, __a2, __a3);
}

inline int setpeername(int __a1, struct sockaddr *__a2, socklen_t __a3)
{
      return _xsetpeername(__NETLIB_VERSION__, __a1, __a2, __a3);
}



#endif      /* ifndef __cplusplus */

#endif      /* KDE_XENV_SOCKET_H */
